package vsp.uloha14;

import java.util.Random;

/**
 * 1. uloha VSP
 * 4. priklad: Generovani nahodnych cisel - exponencialni rozdeleni
 * 
 * @author Jiri Kucera (kalwi@students.zcu.cz)
 */
public class Main {

    public static void main(String[] args) {

	try {
	    if (args.length == 0) {
		Random rand = new Random();
		double lambda;

		lambda = rand.nextDouble() * 10;
		compute(100000, lambda);

		lambda = rand.nextDouble() * 10;
		compute(100000, lambda);

	    } else if (args.length == 2) {
		compute(Integer.valueOf(args[0]), Double.valueOf(args[1]));
	    } else {
		throw new Exception();
	    }

	} catch (Exception e) {
	    System.out.println("Pouziti:\njava -jar vsp.jar <pocet> <lambda>");
	}


    }

    /**
     * Spusti vypocet s uvedenymi parametry
     * @param count pocet generovanych cisel
     * @param lambda parametr lambda exponencialniho rozdeleni
     */
    private static void compute(int count, double lambda) {
	Statistics s = new Statistics(count, lambda);

	System.out.println("E_teorie=" + s.getTheoreticalExpectedValue());
	System.out.println("D_teorie=" + s.getTheoreticalVariance());
	System.out.println("E_vypocet=" + s.getEvaluatedExpectedValue());
	System.out.println("D_vypocet=" + s.getEvaluatedVariance());
	
	System.out.println("");

	System.out.println("Histogram (pocet = " + count + ", lambda = " + lambda + "):");

	int[] histogram = s.getHistogram();
	
	for (int i = 0; i < histogram.length; i++) {
	    System.out.print(String.format("%8.4f", s.getHistogramLegend()[i]) + ": " );

	    for (int j = 0; j < histogram[i]; j++) {
		System.out.print("*");
	    }

	    System.out.println("");
	}
	System.out.println("");
    }

}
